package io.humanteq.hqm_ltv

import androidx.annotation.NonNull

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.humanteq.hq_core.HQSdk
import android.util.Log
import io.humanteq.hq_core.interfaces.HQCallback

import android.content.Context


/** HqmLtvPlugin */
class HqmLtvPlugin : FlutterPlugin, MethodCallHandler {
    private lateinit var channel: MethodChannel
    private lateinit var context: Context

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        channel = MethodChannel(flutterPluginBinding.binaryMessenger, "hqm_ltv")
        channel.setMethodCallHandler(this)
        context = flutterPluginBinding.applicationContext
    }

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
        if (call.method == "init") {
            val key: String = call.argument("key")!!
            val isDebug: Boolean = call.argument("isDebug")!!

            HQSdk.init(context,
                    key,
                    isDebug,
                    false,
                    object : HQCallback<Unit> {
                        override fun onSuccess(data: Unit?) {
                        }

                        override fun onError(ex: kotlin.Throwable?) {
                            Log.e("hqm_ltv", "Init error: " + ex?.message)
//                            result.error("init error", ex?.message, null)
                        }
                    })

            result.success(null)
        } else if (call.method == "log") {
            val eventName: String = call.argument("eventName")!!
            val data: Map<String, Any> = call.argument("data")!!

            HQSdk.logEvent(eventName, data)

            result.success(null)
        } else {
            result.notImplemented()
        }
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        channel.setMethodCallHandler(null)
    }
}
